; _Ps Codice

; Include "HJConst.JSH"; file costanti predefinito di Jaws
Include "_PsConst.JSH"; File personale delle costanti
Include "_PsGlobals.JSH"; file personale delle variabili globali
Include "_PsMessages.JSM"; File personale dei messaggi

Script InserisceFirma ()
MetteTesto (INIZIO_PERSONALE, RIGA_VUOTA); invia l'etichetta Personale alla funzione
EndScript

Script MuoveElementoSuccessivo ()
If !SiamoNellaFinestra (MANAGER) Then; se non si  nella finestra corretta,
PronunciaEsegue (CONTROL_FRECCIAGIU); attiva lo script di Jaws con i tasti indicati,
Return; e interrompe il flusso
EndIf; fine controllo finestra
TypeKey (F2); richiama il comando originale
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndScript

Script MuoveElementoPrecedente ()
If !SiamoNellaFinestra (MANAGER) Then; se non si  nella finestra corretta,
PronunciaEsegue (CONTROL_FRECCIASU); attiva lo script di Jaws con i tasti indicati,
Return; ed interrompe il flusso
EndIf; fine controllo finestra
TypeKey (SHIFT_F2); richiama il comando originale
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndScript

Script TrovaTesto ()
GestisceDato (SALVA); tenta il salvataggio della posizione corrente
ComandoTrova (); richiama il comando dell'applicativo per la ricerca testo
EndScript

Script SelezionaDalContrassegno ()
If NumeroVersione () >= NUOVE Then; se quella in uso  una versione di Jaws dalla 2018,
PerformScript SelectTextBetweenMarkedPlaceAndCurrentPosition (); esegue lo script nativo
Else; Altrimenti, per le versioni precedenti,
SelectFromSavedLocationToCurrent (); chiama la funzione originale
EndIf; fine controllo versione
EndScript

Script SalvaContrassegno ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script SostituisceTesto ()
GestisceDato (SALVA, CHIUDE); salva la posizione simulando la chiusura del documento
PronunciaEsegue (); ripete i tasti premuti, leggendo il nome dello script
EndScript

Script DataOra ()
Var
Int iOre, ; ore rimanenti alla mezzanotte
Int iMinuti, ; minuti mancanti all'ora successiva
String sOre; messaggio testuale sul tempo rimanente

SayMessage (OT_ERROR, SysGetDate (msgDataEstesa)); pronuncia la data,
SayMessage (OT_ERROR, SysGetTime (msgOraEstesa)); e legge anche l'orario
Let iOre = 24 - (StringToInt (SysGetTime ("H")) + 1); calcola le ore alla mezzanotte,
Let iMinuti = 60 - StringToInt (SysGetTime ("m")); poi calcola anche i minuti rimanenti
Let sOre = FormatString ( ; compone il messaggio, specificando:
msgMezzanotte, ; parametro1, il messaggio creato con i due segnaposti numerati,
iOre, ; parametro2, il dato sulle ore, da sostituire al segnaposto %1,
iMinuti); parametro3, il dato sui minuti, da sostituire al segnaposto %2
SayMessage (OT_ERROR, sOre); legge il messaggio formattato
EndScript

Script AvviaCronometro ()
Var String sMessaggio; l'avviso formattato
Let gnTempoIniziale = GetTickCount (); registra i millisecondi trascorsi dall'avvio
Let sMessaggio = FormatString ( ; formatta l'avviso da leggere
msgOraAvvio, ; parametro1, il messaggio base
SysGetTime ()); parametro2, l'ora da inserire nell'avviso
SayMessage (OT_ERROR, sMessaggio); legge l'avviso formattato
Beep (); emette un segnale acustico
EndScript

Script TempoTrascorso ()
Var
Int iValore, ; il tempo trascorso in millisecondi
Int iSecondi, ; i secondi trascorsi
String sUltimaParte, ; la parte finale dei millisecondi convertiti in testo
String sCentesimi, ; la stringa con i centesimi di secondo
Int iMinuti, ; numero dei minuti trascorsi
Int iOre; numero delle ore trascorse

Let iValore = GetTickCount () - gnTempoIniziale; sottrae il tempo di partenza all'attuale
Let iSecondi = iValore / 1000; converte il valore in secondi
Let sUltimaParte = StringRight (IntToString (iValore), 3); estrae le tre cifre a destra
Let sCentesimi = StringLeft (sUltimaParte, 2); preleva le prime due cifre a sinistra
If iSecondi < MINUTO Then; se il tempo trascorso  inferiore al minuto, legge l'avviso
SayFormattedMessage (OT_HELP, msgBaseTempo, NULLO, iSecondi, sCentesimi)
ElIf iSecondi < ORA Then; se invece siamo sotto all'ora,
Let iMinuti = iSecondi / MINUTO; calcola i minuti trascorsi,
Let iSecondi = iSecondi - (iMinuti * MINUTO); sottrae ai secondi quelli relativi ai minuti,
SayFormattedMessage (OT_HELP, msgMinuti, NULLO, iMinuti, iSecondi, sCentesimi);
Else; se invece siamo sopra all'ora di tempo trascorso,
Let iOre = iSecondi / ORA; calcola le ore trascorse suddividendo i secondi,
; quindi calcola i minuti dividendo i secondi rimasti dopo aver tolto quelli delle ore,
Let iMinuti = (iSecondi - (iOre * ORA)) / MINUTO
; e infine aggiorna i secondi togliendo quelli compresi nelle ore e nei minuti
Let iSecondi = iSecondi - ((iOre * ORA) + (iMinuti * MINUTO))
SayFormattedMessage (OT_HELP, msgOre, NULLO, iOre, iMinuti, iSecondi); legge l'avviso
EndIf; fine controllo tempo
EndScript

Script Saluto ()
Var
Int iOra, ; ora corrente
Int iValore; dato da estrarre

Let iOra = StringToInt (SysGetTime (_H)); rileva l'ora corrente
If iOra >= MATTINO && iOra < POMERIGGIO Then; se si  nel mattino,
Let iValore = 1; imposta il numero del dato da estrarre
ElIf iOra >= POMERIGGIO && iOra < SERA Then; se invece si  nel pomeriggio,
Let iValore = 2; imposta il dato relativo
ElIf iOra >= SERA && iOra < NOTTE Then; se si  in orario serale,
Let iValore = 3; imposta il dato
ElIf iOra >= NOTTE || iOra < MATTINO Then; se infine si  nell'orario notturno,
Let iValore = 4; imposta il dato
EndIf; fine controllo ora corrente
SayMessage (OT_HELP, StringSegment (lstSaluti, PIPE, iValore)); legge il saluto estratto
EndScript

Script CopiaRiga ()
If !StringTrimLeadingBlanks (GetLine ()) Then; se nella riga non  presente del testo,
SayMessage (OT_HELP, msgRigaVuota, msgRigaVuota_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo riga corrente
SpeechOff (); spegne la sintesi
JAWSEnd (); porta il cursore a fine riga
SelectFromStartOfLine (); seleziona la riga corrente
SpeechOn (); riattiva la sintesi
Refresh (); resetta la schermata
PerformScript CopySelectedTextToClipboard (); esegue lo script nativo
EndScript

Script AggiungeRiga ()
If !StringTrimLeadingBlanks (GetLine ()) Then; se nella riga non  presente del testo,
SayMessage (OT_HELP, msgRigaVuota, msgRigaVuota_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo riga corrente
SpeechOff (); spegne la sintesi
JAWSEnd (); porta il cursore a fine riga
SelectFromStartOfLine (); seleziona la riga corrente
SpeechOn (); riattiva la sintesi
Refresh (); resetta la schermata
PerformScript AppendSelectedTextToClipboard (); esegue lo script nativo
EndScript

Script AperturaCodice ()
MetteTesto (lstApreScript, RIGA_VUOTA); invia le dichiarazioni di apertura alla funzione
EndScript

Int Function SceltaLivello ()
Return DlgSelectItemInList (; restituisce la scelta effettuata
VociScelta (), ; parametro1, la nostra funzione che compone le voci di scelta
FormatString (ttlSelezione, ttlLivelloFinestra, gsNomeFinestra), ; parametro2, testo a video
FALSE); parametro3, valore per disattivare l'ordinamento alfabetico
EndFunction

Handle Function LivelloFinestra (int iLivello)
If iLivello == CORRENTE Then; se stata scelta la prima voce,
Return GetCurrentWindow (); restituisce l'Handle della finestra corrente
ElIf iLivello == REALE Then; se invece si  scelta la seconda voce,
Return GetRealWindow (GetFocus ()); restituisce l'Handle per la prima finestra col titolo
ElIf iLivello == PRINCIPALE Then; Se invece  stata scelta l'ultima voce,
Return GetAppMainWindow (GetFocus ()); restituisce l'Handle della finestra Principale
EndIf; fine controllo livello
EndFunction

Script InfoFinestra ()

Var
int iScelta, ; scelta effettuata
Handle h, ; finestra da leggere
String sLivello, ; livello della finestra
String sInfo; testo del messaggio

Let gsNomeFinestra = NULLO; azzera l'eventuale valore impostato
Let iScelta = SceltaLivello (); imposta il livello della finestra di cui leggere i dati

If !iScelta Then; nel caso la variabile sia 0, essendo stato premuto il tasto Esc o Annulla,
Return; interrompe lo script
EndIf; fine controllo annullamento

Let h = LivelloFinestra (iScelta); imposta l'Handle, sulla base del livello appena scelto

; estrae il nome del livello della finestra e lo imposta nella variabile
Let sLivello = StringSegment (lstLivelliFinestra, PIPE, iScelta)

Let sInfo = FormatString ( ; crea il testo da visualizzare mettendo i dati nei segnaposto
msgDatiFinestra, ; parametro1, nome del messaggio base
sLivello, ; parametro2, testo della voce scelta, al posto di %1,
h, ; parametro3, Handle, al posto di %2
GetControlID (h), ; parametro4, Control ID, al posto di %3
GetWindowName (h), ; parametro5, nome della finestra, al posto di %4
GetWindowType (h), ; parametro6, tipo della finestra, al posto di %5
GetWindowTypeCode (h), ; parametro 7, codice di tipo, al posto di %6
GetWindowSubtypeCode (h), ; parametro 8, codice di Sottotipo, al posto di %7
GetWindowClass (h), ; parametro9, classe della finestra, al posto di %8
hlpFineInfo); parametro10, formula di fine informazioni, al posto di %9

SayMessage (OT_USER_BUFFER, sInfo); invia i dati al Visualizzatore Virtuale

EndScript

String Function CodiceFinestra (int iLivello)
Var Handle h; l'Handle della finestra

Let h = LivelloFinestra (iLivello); determina l'Handle sulla base del livello indicato
If iLivello == CORRENTE Then; se si  richiesto un codice del primo tipo,
Return FormatString ( ; restituisce un messaggio formattato con tre termini
msg3Trattino, ; parametro1, messaggio base con tre segnaposti
GetWindowTypeCode (h), ; parametro2, codice di tipo, al posto di %1
GetWindowSubtypeCode (h), ;parametro3, codice di Sottotipo, al posto di %2
GetWindowClass (h));parametro4, classe della finestra al posto di %3.
ElIf iLivello == REALE ; Se invece si  scelto il livello Reale,
|| iLivello == PRINCIPALE Then; oppure quello principale,
Return FormatString ( ; restituisce un messaggio formattato con due soli termini
msg2Trattino, ; parametro1, messaggio base con due segnaposti
GetWindowName (h), ; parametro2, nome della finestra da mettere al posto di %1
GetWindowClass (h));parametro3, classe della finestra al posto di %2.
EndIf; fine controllo livello
EndFunction

String Function VociScelta ()
Var
Int i, ; contatore del ciclo
String sVoci, ; elenco da restituire
String sNome; nome del livello di finestra

Delay (ATTESA); sospende il flusso per i decimi di secondo impostati
For i = 1 To StringSegmentCount (lstLivelliFinestra, PIPE); scorre le voci nella stringa
If i > 1 Then; se si  dal secondo passaggio in poi,
Let sVoci = sVoci + BELL; inserisce il separatore delle voci
EndIf; fine controllo passaggi
Let sNome = StringSegment (lstLivelliFinestra, PIPE, i); estrae la prima parte della voce
Let sVoci = sVoci + FormatString (msg2Punto, sNome, CodiceFinestra (i)); accoda il codice
EndFor; fine ciclo di scansione livelli
Return sVoci; restituisce l'elenco ricostruito
EndFunction

Void Function MetteTesto (string sDati, int iRitorni)
If CodiceFinestra (CORRENTE) != CODICE_EDITOR Then; se la finestra non  corretta,
TypeCurrentScriptKey (); ripristina i tasti premuti,
Return; e interrompe il flusso
EndIf; fine controllo finestra
Var
Int i, ; contatore del ciclo
Int iRighe, ; numero delle righe copiate
String sRiga; singolo segmento da scrivere

SpeechOff (); spegne la sintesi
; rimuove dal testo eventuali caratteri di ritorno a capo, Ascii 13
Let sDati = StringReplaceSubstrings (sDati, CR, NULLO)
; esegue un ciclo, ripetendolo per il numero di segmenti nella stringa
For i = 1 To StringSegmentCount (sDati, LF)
If i > 1 Then; dal secondo passaggio in poi,
EnterKey (); simula la pressione di Invio, per creare una nuova riga
Let iRighe = iRighe + 1; aggiorna il contatore delle righe copiate
Pause (); sospende momentaneamente il flusso
EndIf; fine controllo passaggi
Let sRiga = StringSegment (sDati, LF, i); estrae il segmento equivalente ad una riga,
TypeString (sRiga); e lo trascrive nel documento
EndFor; fine ciclo scansione testo
If StringRight (sDati, 1) == LF Then; se l'ultimo carattere del testo  quello di nuova linea,
Let iRitorni = iRitorni + 1; aggiunge una unit ai ritorni a capo da creare
EndIf; fine controllo ultimo carattere
For i = 1 To iRitorni; aggiunge eventuali o ulteriori ritorni a capo
EnterKey (); crea un'ulteriore nuova riga
Let iRighe = iRighe + 1; aggiorna il contatore delle righe copiate
EndFor; fine ciclo ritorni a capo
SpeechOn (); riattiva la sintesi
If iRighe Then; se sono state copiate delle righe intere,
If iRighe > 1 Then; se le righe sono pi di una,
Let sDati =FormatString (msgMettiRighe, iRighe); formatta il dato con il numero di righe
EndIf; fine controllo numero righe
SayMessage (OT_ERROR, sDati); legge il messaggio in tono minore
EndIf; fine controllo righe copiate
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndFunction

String Function Nota (int iValore)
Var Int iBase; aggiunta per conversione in lettera
If iValore <= 5 Then; se le note sono fino al Sol,
Let iBase = INIZIO_C; imposta una base per lettere dalla C alla G
Else; altrimenti, se sono note dal La al Do alto,
Let iBase = INIZIO_A; imposta una base per lettere dalla A alla C
EndIf; fine impostazione base
; restituisce il nome del file, opportunamente formattato
Return FormatString (lstFileNote, iValore, MakeCharacterFromValue (iBase + iValore))
EndFunction

Void Function Suona (string sFile, int iRitardo)
PlaySound (FindJAWSSoundFile (sFile + WAV)); suona il file di suoni specificato
If iRitardo Then; se un valore  stato specificato,
Delay (iRitardo); sospende il flusso per i decimi di secondo indicati
EndIf; fine controllo ritardo
EndFunction

Script FraMartino ()
Var
Int iTempo1, ; primo intervallo di tempo
Int iTempo2, ; secondo intervallo di tempo
Int i; contatore dei cicli
Let iTempo1 = 4; imposta il valore intero
Let iTempo2 = 2; imposta un tempo dimezzato
For i = 1 To 2; esegue le prime due battute
Suona (Nota (1), iTempo1)
Suona (Nota (2), iTempo1)
Suona (Nota (3), iTempo1)
Suona (Nota (1), iTempo1)
EndFor; fine prime due battute
For i = 1 To 2; esegue terza e quarta battuta
Suona (Nota (3), iTempo1)
Suona (Nota (4), iTempo1)
Suona (Nota (5), iTempo1)
Delay (iTempo1)
EndFor; fine terza e quarta battuta
For i = 1 To 2; esegue quinta e sesta battuta
Suona (Nota (5), iTempo2)
Suona (Nota (6), iTempo2)
Suona (Nota (5), iTempo2)
Suona (Nota (4), iTempo2)
Suona (Nota (3), iTempo2)
Delay (iTempo2)
Suona (Nota (1), iTempo2)
Delay (iTempo2)
EndFor; fine quinta e sesta battuta
For i = 1 To 2; esegue penultima ed ultima battuta
Suona (Nota (2), iTempo1)
Suona (Nota (5), iTempo1)
Suona (Nota (1), iTempo1)
Delay (iTempo1)
EndFor; fine penultima e ultima battuta
EndScript

String Function NomeArchivio (int iTipo)
If iTipo == CORRENTE Then; se l'archivio da elaborare  quello dell'applicazione attiva,
Return GetActiveConfiguration () + JCF; ne restituisce il nome aggiungendo l'estensione
ElIf iTipo == PERSONALE Then; se invece l'archivio da elaborare  quello personale,
Return PS_FILE + JCF; ne restituisce il nome aggiungendo l'estensione
ElIf iTipo == APP Then; per il file Tasti dell'applicazione attiva,
Return GetActiveConfiguration () + JKM; si serve ancora della funzione di Jaws
ElIf iTipo == JAWS Then; per il file Tasti Predefinito,
Return JAWS_FILE + JKM; utilizza l'altra costante impostata
ElIf iTipo == SEGNI Then; se l'archivio da elaborare  quello per i contrassegni,
; rimuove i riferimenti ai suffissi inglesi dei nomi, ed aggiunge etichetta ed estensione
Return FormatString ( ; restituisce il nome formattato,
msg2, ; messaggio base,
StringReplaceSubstrings (GetActiveConfiguration (), CLASSIC, NULLO), ; rimuove un suffisso,
SUFFISSO_JSI); e ne aggiunge un altro, comprensivo d'estensione
ElIf iTipo == TEMPORANEO Then; se infine  richiesto un archivio solo per la sessione,
Return FormatString ( ; restituisce nome e percorso dell'archivio temporaneo
msg3Controbarra, ; messaggio base,
GetUserSettingsDirectory (), ; percorso completo delle Impostazioni personali,
CARTELLA_SESSIONE, ; nome della sottocartella dove salvare le annotazioni,
GetActiveConfiguration () + TMP); etichetta dell'applicativo corrente
EndIf; fine controllo tipo archivio
EndFunction

String Function ScriveLivelloFinestra (string sNomeTipo, int iLivello)
If IniWriteInteger ( ; Tenta di scrivere il valore nella configurazione Personale
TIPI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
iLivello, ; parametro3, il valore numerico con il livello di finestra
NomeArchivio (PERSONALE)); parametro4, il file configurazione Personale, dato fisso
Then; se la scrittura riesce, prima legge l'avviso,
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sNomeTipo)
Return TRUE; poi restituisce l'esito positivo
Else; altrimenti, prima avvisa dell'errore,
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sNomeTipo)
Return FALSE; poi restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Int Function LeggeLivelloFinestra (string sNomeTipo)
Return IniReadInteger ( ; restituisce il valore memorizzato nel file configurazione Personale
TIPI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
FALSE, ; parametro3, il valore restituito in caso di mancata lettura, dato fisso
NomeArchivio (PERSONALE)) ; parametro4, file di configurazione Personale
EndFunction

Int Function ScriveCodiceFinestra (string sNomeTipo, string sCodice)
If IniWriteString ( ; Tenta di scrivere il dato nel file dell'applicazione corrente
DATI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
sCodice, ; parametro3, il dato testuale con il codice della finestra
NomeArchivio (CORRENTE)); parametro4, file configurazione dell'applicativo corrente
Then; se la scrittura riesce, prima legge l'avviso,
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sNomeTipo)
Return TRUE; poi restituisce l'esito positivo
Else; altrimenti, prima avvisa dell'errore,
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sNomeTipo)
Return FALSE; poi restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

String Function LeggeCodiceFinestra (string sNomeTipo)
Return IniReadString ( ; restituisce il dato memorizzato nel file per l'applicazione corrente
DATI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
NULLO, ; parametro3, la stringa vuota restituita in caso di mancata lettura, dato fisso
NomeArchivio (CORRENTE)); parametro4, file archivio dell'applicativo ottenuto dalla funzione
EndFunction

Script Prova ()
Var
String sNomeFile, ; nome completo del documento
String sEstensione; estensione del file
If DocumentoCorrente (sNomeFile, sEstensione, IsSameScript ()) Then; se i dati ci sono,
SayFormattedMessage (OT_HELP, msg2Virgola, NULLO, sNomeFile, sEstensione); li legge
EndIf; fine controllo Nome del documento
EndScript

String Function LeggeChiavi (int iTipo, string sSezione)
Return IniReadSectionKeys ( ; legge i dati specificati dall'archivio impostato
sSezione, ; parametro1, nome della sezione da cui leggere i dati
NomeArchivio (iTipo)); parametro2, nome dell'archivio del tipo specificato
EndFunction

Int Function DefinisceLivello (string sNomeTipo, int ByRef iLivello)
Var Int iScelta; un valore da impostare
; trasmette con una variabile globale il nome del tipo di finestra di cui scegliere il livello
Let gsNomeFinestra = sNomeTipo
While !iScelta; esegue un ciclo, proponendo la richiesta finch la scelta rimane a zero
Let iScelta = SceltaLivello (); determina il livello cui leggere i dati della finestra
If !iScelta Then; se non  stata effettuata nessuna scelta,
Let iScelta = ExMessageBox (; propone una conferma all'uscita
msgConfermaUscita, ; parametro1, messaggio per il corpo della finestra di dialogo
ttlConfermaUscita, ; titolo della finestra di conferma
MB_YESNO|MB_ICONQUESTION); parametro3, tipo di controllo e dell'icona
If iScelta == IDNO Then; se  stato scelto No,
Let iScelta = FALSE; azzera il valore per consentire un ritorno all'inizio del ciclo
EndIf; fine controllo conferma
EndIf; fine controllo scelta effettuata
EndWhile; fine del ciclo di scelta
If iScelta == IDYES Then; se si  confermata l'uscita dalla procedura,
Return FALSE; restituisce un risultato nullo
ElIf ScriveLivelloFinestra (sNomeTipo, iScelta) Then; se la scrittura dei dati riesce,
Let iLivello = iScelta; trasmette la scelta effettuata
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo ritorno
EndFunction

Void Function NuovoTipoFinestra (string ByRef sNomeTipo, int ByRef iLivello)
Var Int iTasto; il valore del tasto premuto
Let sNomeTipo = gsNomeFinestra; si premette il nome casomai segnalato dalla procedura
Let iTasto = InputBox ( ; Consente di specificare un nuovo tipo di finestra
msgInserisciRiga, ; parametro1, l'avviso per il prompt della casella di editazione
ttlTipoNuovoFinestra, ; parametro2, titolo della finestra di dialogo
sNomeTipo); parametro3, il nome da impostare, per riferimento
If sNomeTipo Then; se un nuovo tipo  stato definito,
If DefinisceLivello (sNomeTipo, iLivello) Then; se viene scelto anche un livello,
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se la scelta  stata annullata,
Let sNomeTipo = NULLO; cancella il dato
EndIf; fine controllo scelta livello
EndIf; fine controllo impostazione tipo
Return FALSE; se nessun altro controllo  intervenuto, restituisce un risultato nullo
EndFunction

Int Function CancellaChiave (int iTipo, string sSezione, string sChiave)
Return IniRemoveKey ( ; cancella il dato della chiave specificata
sSezione, ; parametro1, nome della sezione in cui cercare il dato
sChiave, ; parametro2, chiave del dato da rimuovere
NomeArchivio (iTipo)); parametro3, nome dell'archivio del tipo specificato
EndFunction

Int Function ControllaScritturaCodice (string sNomeTipo, string sCodice)
Var
String sMessaggio, ; il testo da presentare a video
Int iTasto; il tasto premuto
; formatta il messaggio base aggiungendo tipo finestra e nome applicativo
Let sMessaggio = FormatString (msgConfermaDati, sNomeTipo, GetActiveConfiguration ())
Let iTasto = ExMessageBox ( ; chiede conferma alla scrittura del codice
sMessaggio, ; parametro1, il testo per la casella di sola lettura
ttlConfermaDati, ; parametro2, titolo della schermata
MB_YESNOCANCEL|MB_USERICON); parametro3, tipo di conferma e icona di avviso

If iTasto == IDYES Then; se si  confermata la registrazione del codice identificativo,
Return ScriveCodiceFinestra (sNomeTipo, sCodice); tenta la scrittura e ne restituisce l'esito
ElIf iTasto == IDNO Then; se invece si  scelto di non confermarla tramite l'omonimo pulsante,
ScriveCodiceFinestra (sNomeTipo, NESSUNO); inibisce ulteriori controlli per l'applicazione
EndIf; fine controllo conferma
Return FALSE; se non si conferma la scelta, si restituisce comunque un risultato nullo
EndFunction

Script DefinisceTipiFinestra ()
Var
String sElenco, ; elenco tipi di finestra registrati
Int iScelta, ; scelta effettuata
String sNomeTipo, ; il tipo di finestra scelto
Int iLivello; il livello di finestra di cui rilevare i dati

Let sElenco = LeggeChiavi (PERSONALE, TIPI_FINESTRE); rileva l'elenco delle voci
If sElenco Then; se sono stati rilevati dei tipi di finestra,
Let sElenco = sElenco + PIPE + lstNuovoTipo; aggiunge la voce per sceglierne una nuova
; Consente di scegliere un tipo di finestra esistente o di impostarne uno nuovo
Let iScelta = DlgSelectItemInList (sElenco, ; parametro1, elenco delle scelte possibili
FormatString (ttlTipiFinestre, lstNuovoTipo, msgInfoScelte), ; parametro2, messaggio
FALSE);parametro3, ordinamento alfabetico disattivato
If iScelta == FALSE Then; se non  stata impostata alcuna scelta,
Return; interrompe il flusso
ElIf iScelta < StringSegmentCount (sElenco, PIPE) Then; se la voce scelta non  l'ultima
Let sNomeTipo = StringSegment (sElenco, PIPE, iScelta); estrae la voce dall'elenco
Let iLivello = LeggeLivelloFinestra (sNomeTipo); rileva il livello salvato per il tipo di finestra
EndIf; fine controllo scelta
EndIf; fine controllo tipi registrati
If !sNomeTipo Then; se il tipo di finestra non  stato definito,
NuovoTipoFinestra (sNomeTipo , iLivello); imposta, e trasmette, tipo e livello della finestra
EndIf; fine controllo presenza dato
If sNomeTipo Then; se un tipo di finestra  impostato,
If ControllaScritturaCodice (sNomeTipo, CodiceFinestra (iLivello)) Then; se i dati si salvano,
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo scrittura
EndIf; fine controllo tipo finestra
Return FALSE; se nessun altro controllo  intervenuto, restituisce un risultato nullo
EndScript

Int Function SiamoNellaFinestra (string sNomeTipo, int iAiuto)
Var
Int iLivello, ; il livello della finestra di cui leggere i dati
String sCodiceConfronto ; il dato registrato da confrontare

; Rileva il livello del tipo di finestra specificato
Let iLivello = LeggeLivelloFinestra (sNomeTipo)
If !iLivello Then; se il livello non  stato ancora registrato,
If !iAiuto Then; se non  attiva la fase,
If LeggeChiavi (CORRENTE, DATI_FINESTRE) ; se sono salvati dei dati per le finestre,
&& gsNomeFinestra != sNomeTipo Then; e se un messaggio non  gi stato letto,
SayFormattedMessage (OT_ERROR, hlpNoLivello, NULLO, sNomeTipo); avvisa dell'errore,
Let gsNomeFinestra = sNomeTipo; poi evita la ripetizione immediata del messaggio
EndIf; fine controllo registrazione dati
Return FALSE; interrompe il flusso, restituendo un risultato nullo
ElIf !DefinisceLivello (sNomeTipo, iLivello) Then; anche se un livello non viene poi scelto,
Return FALSE; si interrompe il flusso
EndIf; fine controllo Aiuto
EndIf; fine controllo presenza livello

; rileva il dato registrato per l'applicativo corrente
Let sCodiceConfronto = LeggeCodiceFinestra (sNomeTipo)
If sCodiceConfronto Then; se un dato  stato rilevato,
If CodiceFinestra (iLivello) == sCodiceConfronto Then; se i due codici corrispondono,
Return TRUE; restituisce l'esito positivo
ElIf sCodiceConfronto == NESSUNO Then; se invece il codice  quello di annullamento,
Return FALSE; interrompe il flusso restituendo un valore nullo
Else; altrimenti, se il confronto fallisce,
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpNoFinestra, hlpNoFinestra_corto); legge l'avviso
EndIf; fine controllo aiuto
Return FALSE; in ogni caso, interrompe il flusso restituendo un risultato nullo
EndIf; fine controllo confronto
EndIf; fine controllo presenza codice

If iAiuto Then; se  attiva la fase,
Return ControllaScritturaCodice (sNomeTipo, CodiceFinestra (iLivello)); chiede conferma
Else; altrimenti, dato che il controllo  fallito,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo aiuto
EndFunction

Script CercaRipetiSuccessivo ()
If SiamoNellaFinestra (EDITING, IsSameScript ()) Then; se si  in una finestra di editazione,
TypeKey (F3); richiama il comando originale
Pause ()
SayLine (); legge la riga corrente
Else; altrimenti, se non si tratta della finestra corretta,
TypeCurrentScriptKey (); ripete i tasti di attivazione dello script
EndIf; fine controllo finestra
EndScript

Script CercaRipetiPrecedente ()
If SiamoNellaFinestra (EDITING, IsSameScript ()) Then; se si  in una finestra di editazione,
TypeKey (SHIFT_F3); richiama il comando originale
Pause ()
SayLine (); legge la riga corrente
Else; altrimenti, se non si tratta della finestra corretta,
TypeCurrentScriptKey (); ripete i tasti di attivazione dello script
EndIf; fine controllo finestra
EndScript

Void Function PronunciaEsegue (string sTasti, int iRipeti)
If sTasti; se  sono stati specificati dei tasti,
&& !iRipeti Then; e non si  indicato alcun secondo parametro,
PerformScriptByName (GetScriptAssignedTo (sTasti)); esegue lo script abbinato ai tasti,
Return; e interrompe il flusso
EndIf; fine controllo esecuzione
If !sTasti Then; se non  stato indicato alcun tasto,
Let sTasti = GetCurrentScriptKeyName (); rileva gli ultimi tasti premuti
EndIf; fine controllo tasti
TypeKey (sTasti); invia i tasti all'applicazione o al sistema operativo
If iRipeti Then; se  stata impostata la forzatura della ripetizione tasti,
Let sTasti = GetCurrentScriptKeyName (); imposta i tasti solo per la lettura del nome script
EndIf; fine controllo ripetizione forzata
SayMessage (OT_ERROR, GetScriptAssignedTo (sTasti)); legge il nome del relativo script
EndFunction

Void Function ComprimeDati (string sFile, string sSezioni, ; prima riga con due parametri,
string ByRef sChiavi, string ByRef sDati); e seconda riga, con gli altri due
Var
Int j, ; contatore del ciclo primario
Int k, ; contatore del secondo ciclo
String sSezione, ; sezione del file da leggere
String sElenco, ; elenco temporaneo delle chiavi
String sChiave, ; chiave del dato
String sDato; singolo dato da leggere

For j = 1 To StringSegmentCount (sSezioni, PIPE); scorre le sezioni da leggere
Let sSezione = StringSegment (sSezioni, PIPE, j); estrae una singola sezione
Let sElenco = IniReadSectionKeysEx (sSezione, UTENTE, sFile); rileva le chiavi dei dati
For k = 1 To StringSegmentCount (sElenco,PIPE); scorre l'elenco appena rilevato
Let sChiave = StringSegment (sElenco, PIPE, k); ne estrae la singola chiave
Let sDato = IniReadStringEx (sSezione, sChiave, NULLO, UTENTE, sFile); rileva il dato
If !StringSegmentIndex (sChiavi, PIPE, sChiave, TRUE) Then; se la chiave non c',
If (j + k) >2 Then; se non si  al primo passaggio,
Let sChiavi = FormatString (msg2Pipe, sChiavi, sChiave); la aggiunge al primo elenco,
Let sDati = FormatString (msg2Pipe, sDati, sDato); e aggiunge anche il dato rilevato
Else; altrimenti,
Let sChiavi = sChiave; inizializza il primo elenco,
Let sDati = sDato; ed imposta anche il secondo
EndIf; fine controllo passaggi
EndIf; fine controllo chiavi registrate
EndFor; fine scorrimento chiavi
EndFor; fine scorrimento sezioni
EndFunction

Script AiutoInLinea ()
Var
Int j, ; contatore del ciclo primario
Int k, ; contatore del secondo ciclo
String sFile, ; file tasti da elaborare
String sTitolo, ; titolo per inizio informazioni
String sPrimi, ; elenco iniziale dei tasti
String sChiavi, ; elenco combinazioni tasti rilevate
String sDati, ; nomi di script abbinati ai tasti
String sTasto, ; singola combinazione tasti che funge da chiave
String sNome, ; singolo script abbinato
String sInfo; informazioni da visualizzare

EnsureNoUserBufferActive (); chiude eventuali schermate del Visualizzatore Virtuale
For j = APP To JAWS; scorre i tipi di file tasti
Let sFile = NomeArchivio (j); imposta il nome del file tasti da elaborare
; crea gli elenchi leggendo dalle sezioni specificate dell'archivio
ComprimeDati (sFile, lstSezioniTasti, sChiavi, sDati)
If sChiavi Then; se dei tasti sono stati rilevati,
If j == APP Then; se si  al primo passaggio,
; formatta il titolo dell'Aiuto con il nome dell'applicativo corrente
Let sTitolo = FormatString (hlpInfoApp, GetActiveConfiguration ())
Let sPrimi = sChiavi; registra il primo elenco di tasti
ElIf j == JAWS Then; se si  invece al secondo passaggio,
Let sTitolo = hlpInfoJaws; imposta il relativo titolo per l'Aiuto
If UserBufferGetLength ()Then; se nel Visualizzatore Virtuale  presente del testo,
UserBufferAddText (FormatString (msgTraVuote, sTitolo)); inizializza la seconda parte
EndIf; fine controllo testo Aiuto
EndIf; fine controllo passaggi
For k = 1 To StringSegmentCount (sChiavi, PIPE); scorre le combinazioni tasti rilevate
Let sTasto = StringSegment (sChiavi, PIPE, k); estrae la combinazione tasti da verificare
If j == APP ; se si  al primo passaggio,
|| !StringSegmentIndex (sPrimi, PIPE, sTasto, TRUE) Then; o, se i tasti non ci sono gi,
If !UserBufferGetLength ()Then; se il Visualizzatore Virtuale   vuoto,
UserBufferAddText (sTitolo + LF); lo inizializza con l'apposito titolo
EndIf; fine controllo creazione testo
If sTasto != GetCurrentScriptKeyName () Then; se i tasti non sono quelli di attivazione,
Let sNome = StringSegment (sDati, PIPE, k); estrae il nome dello script abbinato
Let sInfo = GetScriptSynopsis (sNome); legge il sommario dello script
If !sInfo Then; se nessuna informazione  stata rilevata,
Let sInfo = sNome + PUNTO; usa come informazione il nome dello script
EndIf; fine controllo presenza informazioni
UserBufferAddText ( ; compone la riga d'informazioni, comprensiva del link,
FormatString (hlpInfoScript, sInfo, sTasto), ; formatta il testo da visualizzare,
FormatString (hlpInfoLink, sNome), ; formatta anche il comando da eseguire,
sNome); e aggiunge il nome per l'elenco dei link
EndIf; fine controllo tasti validi
EndIf; fine controllo tasti gi elaborati
EndFor; fine ciclo scorrimento chiavi
EndIf; fine controllo presenza chiavi
EndFor; fine ciclo scorrimento file
If UserBufferGetLength ()Then; se nel Visualizzatore Virtuale  presente del testo,
UserBufferActivate (); visualizza la schermata d'informazioni,
; quindi, prima formatta un testo con i tasti dello script chiamante e la formula di chiusura,
Let sInfo = FormatString (hlpUltimaInfo, GetCurrentScriptKeyName (), hlpFineInfo);
; poi, la trasmette al Buffer, avviandone la lettura.
RedirectToUserBuffer (sInfo)
EndIf; fine controllo presenza testo
EndScript

Int Function ScriveValore (int iTipo, string sSezione, string sChiave, int iValore, int iAiuto)
Var String sArchivio; il nome dell'archivio in cui scrivere
Let sArchivio = NomeArchivio (iTipo); ricava il nome dell'archivio dall'apposita funzione
; Tenta di scrivere il valore numerico nell'archivio del tipo specificato
If IniWriteInteger (sSezione, sChiave, iValore, sArchivio) Then; se la scrittura riesce,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sArchivio)
EndIf; fine controllo Aiuto
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; altrimenti, se la scrittura fallisce,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sArchivio)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Int Function LeggeValore (int iTipo, string sSezione, string sChiave)
; restituisce il valore numerico memorizzato nell'archivio del tipo indicato
Return IniReadInteger (sSezione, sChiave, FALSE, NomeArchivio (iTipo))
EndFunction

Int Function ScriveDato (int iTipo, string sSezione, string sChiave, string sDato, int iAiuto)
Var String sArchivio; il nome dell'archivio in cui scrivere
Let sArchivio = NomeArchivio (iTipo); ricava il nome dell'archivio dall'apposita funzione
; Tenta di scrivere il dato testuale nell'archivio del tipo indicato
If IniWriteString (sSezione, sChiave, sDato, sArchivio) Then; se la scrittura riesce,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sArchivio)
EndIf; fine controllo Aiuto
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; altrimenti,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sArchivio)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

String Function LeggeDato (int iTipo, string sSezione, string sChiave)
; restituisce il dato testuale memorizzato nell'archivio del tipo indicato
Return IniReadString (sSezione, sChiave, NULLO, NomeArchivio (iTipo))
EndFunction

String Function NomeNelTitolo (string sPrima, string sDopo, int iAiuto)
Var
String sAttiva, ; nome dell'applicazione corrente
Int iParte, ; segmento di stringa individuato
String sTitolo, ; titolo da salvare per l'applicativo
Int iPrima, ; punteggiatura trovata nella prima stringa
Int iDopo, ; punteggiatura nella seconda stringa
String sNome; dato da restituire

Let sAttiva = StringLower (GetActiveConfiguration ());fissa l'etichetta per l'applicazione
; se l'etichetta si rileva nella parte iniziale della stringa,
If StringContains (StringLower (sPrima), sAttiva) Then
Let iParte = SECONDA; allora il nome si trova nella seconda parte
; se invece l'etichetta si trova nella seconda parte,
ElIf StringContains (StringLower (sDopo), sAttiva) Then
Let iParte= PRIMA; allora il nome si trova in quella iniziale
Else; se invece l'etichetta dell'applicativo non  stata rilevata,
Let iPrima = StringContains (sPrima, PUNTO); cerca un carattere Punto nella parte iniziale,
Let iDopo = StringContains (sDopo, PUNTO); e lo cerca anche nella parte finale del dato
If iPrima && !iDopo Then; se il punto  presente nella prima parte e non nella seconda,
Let iParte = PRIMA; allora il nome deve trovarsi nella prima parte
ElIf iDopo && !iPrima Then; se invece il punto  nella seconda parte e non nella prima,
Let iParte = SECONDA; allora il nome dovrebbe essere nella seconda parte
EndIf; fine controllo punto nel dato
EndIf; fine controllo etichetta applicativo

If !iParte ; se la parte dove si trova il nome non  stata rilevata,
&& iAiuto Then; ma la fase omonima  stata specificata,
If LeggeDato (CORRENTE, DATI_FILE, AIUTO) == NESSUNO Then; se la fase non  attiva,
SayMessage (OT_ERROR, hlpNoAiuto, hlpNoAiuto_corto); avvisa di tale annullamento,
Return NULLO; e restituisce una stringa vuota
EndIf; fine controllo annullamento Aiuto
Delay (1, TRUE); sospende momentaneamente il flusso e disattiva funzioni di autolettura
; consente di scegliere in quale tra le due parti del titolo sia presente il nome del file
Let iParte = DlgSelectItemInList (FormatString (lstParti, sPrima, sDopo), ttlParti, FALSE)
If iParte == TERZA Then; se si  scelto di annullare l'analisi,
ScriveDato (CORRENTE, DATI_FILE, AIUTO, NESSUNO); annota la scelta,
Return NULLO; e restituisce una stringa vuota
EndIf; fine controllo scelte
EndIf; fine primo controllo rilevazione parte

If !iParte Then; se la porzione dove si trova il nome non  ancora stata individuata,
Return NULLO; restituisce una stringa vuota
EndIf; fine secondo controllo rilevazione parte
If iParte == PRIMA Then; se il nome  stato rilevato nella parte iniziale,
Let sNome = sPrima; ne memorizza il testo per restituirlo,
Let sTitolo = SEPARA_NOME + sDopo; e compone anche il titolo da salvare nell'archivio
ElIf iParte == 2 Then; se invece il nome  stato individuato nella parte finale,
Let sNome = sDopo; ne copia il testo per la restituzione,
Let sTitolo = sPrima + SEPARA_NOME; e compone anche il titolo da archiviare
EndIf; fine controllo parte
; salva il nome dell'applicativo rilevato nel titolo, per semplificare le successive ricerche
ScriveDato (CORRENTE, DATI_FILE, TITOLO, FormatString (msgVirgolette, sTitolo))
Return sNome; e restituisce il dato rilevato
EndFunction

String Function TagliaSpazi (string sTesto)
; restituisce il testo senza gli spazi iniziali, finali e consecutivi
Return StringTrimLeadingBlanks (StringTrimTrailingBlanks (sTesto))
EndFunction

String Function TogliePercorso (string sNome)
If !sNome Then; se il parametro passato  vuoto,
Return NULLO; restituisce una stringa vuota, interrompendo il flusso
EndIf; fine controllo parametro
Var
Int i, ; contatore del ciclo
String sTrova; carattere da cercare

For i = 1 To 3; compie le tre iterazioni del ciclo
If i == 1 Then; se si  al primo passaggio,
Let sTrova = CONTROBARRA; imposta il carattere di separazione per i percorsi Windows
ElIf i == 2 Then; se invece si  al secondo,
Let sTrova = BARRA; imposta il separatore nei percorsi web
Else; altrimenti,
Let sTrova = DUE_PUNTI; imposta il separatore tra il nome ed eventuali dati accessori
EndIf; fine controllo passaggio
If StringContains (sNome, sTrova) Then; se il carattere  stato trovato,
; riduce la stringa al segmento a destra dell'ultima occorrenza del carattere
Let sNome = TagliaSpazi (StringSegment (sNome, sTrova, ULTIMA))
EndIf; fine controllo carattere
EndFor; fine ciclo ricerca
Return TagliaSpazi (sNome); restituisce il dato , eliminando gli spazi in eccesso
EndFunction

Int Function DocumentoCorrente (string ByRef sNomeFile, ; intestazione con un parametro,
string ByRef sEstensione, int iAiuto); e seconda riga con gli altri due
Var
String sDato, ; testo del titolo originale
String sTitolo, ; nome dell'applicativo nel titolo
Int iPosiz, ; posizione di un testo in una stringa
int iLungo, ; lunghezza della stringa
String sPrima, ; porzione di testo che precede il separatore
String sDopo, ; porzione del nome che segue il separatore
String sNome; il solo nome del documento

Let sDato = GetWindowName (GetRealWindow (GetFocus ())); rileva il dato originario
Let sTitolo = LeggeDato (CORRENTE, DATI_FILE, TITOLO); legge l'eventuale titolo salvato
If sTitolo Then; se un nome dell'applicativo  stato gi registrato,
Let iPosiz = StringContains (sDato, sTitolo ); cerca tale titolo nel dato
If iPosiz Then; se il titolo  stato individuato,
Let iLungo = StringLength (sTitolo); rileva la lunghezza del titolo
If iPosiz == 1 Then; se il titolo  stato rilevato ad inizio stringa, ne estrae la parte col nome
Let sNomeFile = TagliaSpazi (SubString (sDato, iLungo + 1, StringLength (sDato) - iLungo))
Else; se invece il nome  stato rilevato nella parte iniziale,
Let sNomeFile = StringLeft (sDato, iPosiz - 1); ne estrae il testo prima
EndIf; fine controllo posizione titolo
EndIf; fine controllo presenza titolo
EndIf; fine controllo registrazione titolo

If !sNomeFile Then; se il nome non  stato ancora individuato,
Let iPosiz = StringContains (sDato, SEPARA_NOME); cerca un separatore nel nome
If iPosiz Then; se tale separatore  stato trovato,
Let sPrima = TagliaSpazi (StringLeft (sDato, iPosiz - 1)); ne estrae la prima parte,
Let iLungo = iPosiz + (StringLength (SEPARA_NOME) - 1); ne segna l'inizio della seconda,
; e la estrae dal dato
Let sDopo = TagliaSpazi (SubString (sDato, iLungo + 1, StringLength (sDato) - iLungo))
; infine, assegna al nome la parte corretta del titolo
Let sNomeFile = NomeNelTitolo (sPrima, sDopo, iAiuto)
Else; se invece il separatore non  stato trovato,
Let sNomeFile = sDato; memorizza il dato nella forma originale
EndIf; fine controllo separatore
EndIf; fine controllo presenza nome del file

If !sNomeFile Then; se non  stato individuato alcun Nome nel titolo,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, msgTitolo)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un valore nullo
EndIf; fine controllo rilevazione del NomeFile
Let sNomeFile = TogliePercorso (sNomeFile); toglie l'eventuale percorso dal dato
Let sNome = PathRemoveExtension (sNomeFile); toglie casomai l'estensione nel NomeFile
If sNome != sNomeFile Then; se i due nomi sono diversi, e quindi esiste una estensione,
; trasmette per riferimento anche l'estensione del nome rilevato
Let sEstensione = StringRight (sNomeFile, StringLength (sNomeFile) - StringLength (sNome))
ElIf StringRight (sNomeFile, 1) == QUADRA_CHIUSA Then; se invece a fine stringa vi  una parentesi quadra,
Let sNome = StringTrimTrailingBlanks (StringSegment (sNomeFile, QUADRA_APERTA, PRIMA))
If PathRemoveExtension (sNome) != sNome Then; se nella stringa  presente un'estensione,
Let sNomeFile = sNome; aggiorna il nome del file completo
Let sNome = PathRemoveExtension (sNomeFile); crea la versione del nome senza estensione,
; trasmette per riferimento l'estensione del nome rilevato
Let sEstensione = StringRight (sNomeFile, StringLength (sNomeFile) - StringLength (sNome))
Else; altrimenti, se un'estensione non c',
Let sEstensione = NULLO; trasmette una stringa vuota
EndIf; fine controllo blocco tra parentesi quadre
Else; altrimenti, se la ricerca di un'estensione ha avuto esito negativo,
Let sEstensione = NULLO; trasmette una stringa vuota
EndIf; fine controllo presenza estensione
Return TRUE; restituisce l'esito positivo
EndFunction

Int Function ControllaSintesi (int iStato, int iAzzera)
If !IsSpeechOff () Then; se la sintesi non  spenta,
If iStato == FALSE Then; se si  impostato un valore nullo,
SpeechOff (iAzzera); spegne la sintesi
EndIf; fine controllo impostazione
Return TRUE; annota di mantenerla accesa, o di riaccenderla, alla successiva chiamata
ElIf iStato == TRUE Then; se invece si  indicata la riattivazione, mentre la sintesi  spenta,
SpeechOn (iAzzera); riattiva la sintesi
EndIf; fine controllo spegnimento
Return FALSE; restituisce un valore nullo
EndFunction

String Function EstraeNumero (string ByRef sTesto, string sOrigine)
Let sTesto = TagliaSpazi (sTesto); rimuove eventuali spazi iniziali e finali
Let sOrigine = TagliaSpazi (sOrigine); li rimuove anche dall'eventuale stringa di origine
If !sOrigine Then; se non  stata indicata una stringa di origine,
If sTesto Then; se per ne  stata indicata una per riferimento,
Let sOrigine = sTesto; la duplica per semplificare il flusso
Else; altrimenti, se nemmeno come primo parametro  stato espresso un testo,
Return NULLO; restituisce una stringa vuota
EndIf; fine controllo primo parametro
EndIf; fine controllo secondo parametro
Var
Int iPartenza, ; lunghezza della stringa indicata
Int iPosiz, ; puntatore di estrazione testo
String sCarattere; singolo carattere testuale

Let iPartenza = StringLength (sOrigine); registra la lunghezza del dato testuale
Let iPosiz = iPartenza; duplica il valore, per far partire il ciclo
While iPosiz; continua finch il contatore rimane positivo
Let sCarattere = SubString (sOrigine, iPosiz, 1); estrae un singolo carattere dal testo
If sCarattere == ZERO ; se il testo corrisponde alla cifra 0 in forma testuale,
|| StringToInt (sCarattere) Then; oppure se tale carattere  un valore numerico,
Let iPosiz = iPosiz - 1; aggiorna il puntatore all'indietro
Else; altrimenti, se il carattere non  un numero,
Let sTesto = StringLeft (sOrigine, iPosiz); trasmette il resto del dato testuale prima della cifra,
Return StringRight (sOrigine, iPartenza - iPosiz); e restituisce come cifra la parte rimanente di stringa
EndIf; fine controllo carattere
EndWhile; fine ciclo scorrimento stringa
Let sTesto = NULLO; a fine scansione, trasmette solo una stringa vuota,
Return sOrigine; perch restituisce tutto il testo originale come cifra
EndFunction

String Function SeparaParole (string ByRef sPrima, ; prima riga dell'intestazione,
string ByRef sSeconda, string ByRef sUltima); e seconda riga, con gli altri due parametri
Var
String sChiamante, ; il nome dello script chiamante
String sParole, ; Parole in maiuscolo presenti nel nome
Int iConta; numero delle parole rilevate

Let sChiamante = GetScriptAssignedTo (GetCurrentScriptKeyName ()); rileva il nome,
Let sParole = StringMixedCaseToMultiword (sChiamante); e ne separa le parole maiuscole
Let iConta = StringSegmentCount (sParole, SPACE); conta il numero di parole rilevate
Let sPrima = StringSegment (sParole, SPACE, PRIMA); preleva la parola iniziale dello script
If iConta == PRIMA Then; se vi  un'unica parola,
; restituisce l'eventuale numero progressivo a destra del termine trasmesso
Return EstraeNumero (sPrima)
Else; altrimenti, se ci sono altre parole,
Let sUltima = StringSegment (sParole, SPACE, ULTIMA); preleva la parola finale
If iConta > SECONDA Then; se sono rilevate pi di due parole,
Let sSeconda = StringSegment (sParole, SPACE, SECONDA); trasmette la seconda parola
EndIf; fine secondo controllo parole
; restituisce l'eventuale numero progressivo a destra del termine trasmesso
Return EstraeNumero (sUltima)
EndIf; fine primo controllo parole
EndFunction

String Function BarraStato ()
Var String sTesto; il contenuto nella Barra di stato
Let sTesto = GetBottomLineOfWindow (); rileva l'ultima riga in basso con la funzione nativa
If sTesto ; se un qualche contenuto  stato rilevato,
&& (StringContains (sTesto, DIVIDE_ZONE) ; e se nel testo vi  o, il carattere separatore,
|| StringContains (sTesto, SPACE)) Then; oppure, almeno un carattere Spazio,
Return sTesto; restituisce il contenuto rilevato
Else; altrimenti,
Return NULLO; restituisce una stringa vuota
EndIf; fine controllo contenuto
EndFunction

Int Function ControllaSeparatore (string sTesto, string ByRef sDivide)
Var Int iScrivi; valore che attiva la scrittura dei dati

; tenta di leggere un dato dall'archivio dell'applicazione attiva
Let sDivide = LeggeDato (CORRENTE, BARRA_STATO, SEPARATORE)
If !sDivide Then; se nessun separatore delle voci  stato rilevato,
Let sDivide = DIVIDE_ZONE; imposta il carattere di separazione standard
Let iScrivi = TRUE; imposta il valore per la trascrizione
EndIf; fine controllo presenza separatore
If sDivide != NESSUNO ; se il separatore non  quello nullo,
&& StringContains (sTesto, sDivide) Then; e se nella Barra di stato vi  un separatore,
If iScrivi Then; se la trascrizione del dato  stata attivata,
ScriveDato (CORRENTE, BARRA_STATO, SEPARATORE, sDivide); trascrive il separatore,
CancellaChiave (CORRENTE, BARRA_STATO, TESTO); e rimuove un'eventuale trascrizione lineare
EndIf; fine controllo scrittura
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se il carattere non  stato trovato,
Let sDivide = NULLO; resetta il dato,
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo presenza separatore
EndFunction

Void Function AssegnaEsadecimali (int ByRef iOpzioni, int ByRef iDettagli)
If iOpzioni == OK Then; se  stato impostato il primo tipo di finestra di dialogo,
Let iOpzioni = MB_OK; lo aggiorna con il relativo valore esadecimale,
Let iDettagli = MB_ICONHAND; e l'abbinato valore per icona e suoni
ElIf !iOpzioni || iOpzioni == OK_ANNULLA Then; se non  stato specificato nulla, oppure il secondo tipo,
Let iOpzioni = MB_OKCANCEL; aggiorna il valore con il relativo esadecimale
Let iDettagli = MB_ICONQUESTION; e l'abbinato valore per icona e suoni
ElIf iOpzioni == INTERROMPI_RIPROVA_IGNORA Then; se  stato impostato il terzo tipo,
Let iOpzioni = MB_ABORTRETRYIGNORE; aggiorna il valore con il relativo esadecimale
Let iDettagli = MB_ICONASTERISK; e l'abbinato valore per icona e suoni
ElIf iOpzioni == SI_NO_ANNULLA Then; se  stato impostato il quarto tipo,
Let iOpzioni = MB_YESNOCANCEL; aggiorna il valore con il relativo esadecimale,
Let iDettagli = MB_ICONQUESTION; e l'abbinato valore per icona e suoni
ElIf iOpzioni == SI_NO Then; se  stato impostato il quinto tipo,
Let iOpzioni = MB_YESNO; aggiorna il valore con il relativo esadecimale,
Let iDettagli = MB_ICONQUESTION; e l'abbinato valore per icona e suoni
ElIf iOpzioni == RIPROVA_ANNULLA Then; se  stato impostato il sesto tipo,
Let iOpzioni = MB_RETRYCANCEL; aggiorna il valore con il relativo esadecimale
Let iDettagli = MB_ICONASTERISK; e l'abbinato valore per icona e suoni
EndIf; fine controllo tipo
EndFunction

Int Function ChiedeConferma (string sTitolo, string sMessaggio, ; intestazione con due parametri,
int iOpzioni, int iTasto, int iNoSuoni); seconda riga con gli altri tre
Var
Int iStato, ; attivazione della sintesi vocale
int iDettagli, ; valore esadecimale per icona e suoni
Int iScelta; valore della scelta effettuata

Let iStato = ControllaSintesi (TRUE, TRUE); riattiva la sintesi, annotandone l'attuale stato di attivazione
If !sTitolo ; se nessun titolo  stato specificato,
&& !sMessaggio Then; e se non lo  stato neppure un messaggio,
Let sTitolo = msgConfermaUscita; imposta un messaggio come titolo
EndIf; fine controllo titolo e messaggio
AssegnaEsadecimali (iOpzioni, iDettagli); imposta i valori tramite l'apposita funzione
If !iTasto || iTasto == PRIMA Then; se non  stato indicato nulla, oppure il primo valore,
Let iTasto = MB_DEFBUTTON1; aggiorna come predefinito il primo pulsante nella linea dei tasti Tab
ElIf iTasto == SECONDA Then; se invece  stato indicato il secondo valore,
Let iTasto = MB_DEFBUTTON2; aggiorna come predefinito il secondo pulsante
ElIf iTasto == TERZA Then; se invece  stato indicato il terzo valore,
Let iTasto = MB_DEFBUTTON3; aggiorna come predefinito il terzo pulsante
Else; altrimenti,
Let iTasto = MB_DEFBUTTON4; aggiorna come predefinito il quarto pulsante
EndIf; fine controllo tasto predefinito
If !iNoSuoni Then; se non  stata indicata la cancellazione dei suoni,
Let iScelta = ExMessageBox (sMessaggio, sTitolo, iOpzioni|iTasto|iDettagli); propone la classica conferma
Else; altrimenti,
Let iScelta = ExMessageBox (sMessaggio, sTitolo, iOpzioni|iTasto); la propone senza icona e suoni
EndIf; fine controllo sintassi
ControllaSintesi (iStato, TRUE); ripristina, o lascia invariato, il precedente stato di attivazione della sintesi
If iScelta == IDNO Then; se si  premuto il tasto No,
Return -1; restituisce un risultato negativo
ElIf iScelta == IDCANCEL Then; se invece si  premuto Escape o Annulla,
Return FALSE; restituisce un risultato nullo
Else; altrimenti,
Return iScelta; restituisce la scelta operata
EndIf; fine controllo scelta
EndFunction

Int Function DatiStato (string sNome, string sDivide, ; intestazione con due parametri,
string ByRef sInfo, int ByRef iPosiz, int iAiuto); seconda riga con gli altri tre
Var
String sElenco, ; chiavi dei dati registrati
String sChiave, ; singola chiave del dato
Int i, ; contatore del ciclo
Int iValidi; numero dei dati da considerare

; tenta di leggere le informazioni sul dato da estrarre, trasmettendole casomai per riferimento
Let sInfo = StringLower (LeggeDato (CORRENTE, BARRA_STATO, sNome))
If sInfo Then; se delle voci sono state rilevate,
Let iPosiz = StringToInt (StringSegment (sInfo, PIPE, PRIMA)); ne trasmette la posizione,
Return TRUE; e restituisce l'esito positivo
Else; altrimenti, se non  registrata alcuna informazione sul dato richiesto,
If !iAiuto Then; se la fase omonima non  attiva,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo Aiuto
CancellaChiave (CORRENTE, BARRA_STATO, sNome); rimuove l'eventuale chiave
Let sElenco = LeggeChiavi (CORRENTE, BARRA_STATO); rileva le chiavi dei dati registrati
For i = 1 To StringSegmentCount (sElenco, PIPE); scorre i dati rilevati
Let sChiave = StringSegment (sElenco, PIPE, i); estrae una singola chiave dall'elenco
If !StringStartsWith (sChiave, TESTO) ; se il dato non corrisponde ad una delle zone
&& sChiave != SEPARATORE Then; e nemmeno al carattere separatore delle zone,
Let iValidi = iValidi + 1; aggiorna il contatore dei dati da considerare
EndIf; fine controllo dati
EndFor; fine ciclo scansione dati
If sDivide == DIVIDE_ZONE Then; se il separatore  quello standard,
; trasmette la posizione aggiungendo il numero base a quello rilevato
Let iPosiz = iValidi + BASE_ZONE
Else; altrimenti,
Let iPosiz = iValidi + 1; la trasmette aggiungendovi solo un'unit
EndIf; fine controllo separatore
Let sInfo = IntToString (iPosiz); trasmette per riferimento la sola posizione del dato,
ScriveDato (CORRENTE, BARRA_STATO, sNome, sInfo); trascrive i dati rilevati,
Return TRUE; e restituisce l'esito positivo
EndIf; fine controllo presenza voci
EndFunction

String Function InfoStato (string sNome, int iAiuto)
Var;
String sTesto, ; contenuto della Barra di stato
String sDivide, ; carattere di separazione delle voci nella Barra di stato
Int i, ; contatore del ciclo
String sInfo, ; informazioni registrate
Int iPosiz, ; numero del segmento da estrarre
String sDato, ; stringa da estrarre
Int iTotali, ; numero complessivo delle voci da analizzare
Int iVoci , ; contatore delle voci analizzate
String sVoce, ; singola informazione registrata
Int iFase; contatore delle fasi di analisi delle voci

Let sTesto = BarraStato (); rileva la riga di stato tramite l'apposita funzione
If !sTesto Then; se nessun testo  stato rilevato,
If iAiuto Then; se  attiva la fase ,
SayFormattedMessage (OT_ERROR, hlpAttivaBarra, hlpAttivaBarra_corto); legge l'avviso
EndIf; fine controllo aiuto
Return NULLO; in ogni caso, restituisce una stringa vuota
EndIf; fine controllo testo
If !ControllaSeparatore (sTesto, sDivide) Then; se nessun carattere separatore  valido,
If iAiuto Then; se  attiva la fase,
If ChiedeConferma (ttlNoSepara, FormatString (msgImmissione, _O)) Then; se lo si vuole inserire,
Let sDivide = DIVIDE_ZONE; preimposta il carattere predefinito per l'inserimento
If InputBox (msgInserisciRiga, ttlSeparatore, sDivide); Then; se il dato  stato immesso,
ScriveDato (CORRENTE, BARRA_STATO, SEPARATORE, sDivide); trascrive il separatore,
CancellaChiave (CORRENTE, BARRA_STATO, TESTO); e rimuove un'eventuale trascrizione lineare
EndIf; fine controllo inserimento
EndIf; fine controllo conferma
If !sDivide Then; se non vi  alcun separatore,
; trascrive nel file di configurazione Personale:
ScriveDato (CORRENTE, BARRA_STATO, TESTO, sTesto); il testo rilevato,
ScriveDato (CORRENTE, BARRA_STATO, SEPARATORE, NESSUNO); l'assenza del separatore,
Return NULLO; e restituisce una stringa vuota
EndIf; fine controllo presenza dato
EndIf; fine controllo aiuto
EndIf; fine controllo separatore
For i = 1 To StringSegmentCount (sTesto, sDivide); scorre le porzioni del testo separate dal carattere individuato
Let sDato = TagliaSpazi (StringSegment (sTesto, sDivide, i)); estrae la singola zona,
ScriveDato (CORRENTE,BARRA_STATO, FormatString (msg2, TESTO, i), sDato); e la trascrive
EndFor; fine scansione segmenti
If !DatiStato (sNome, sDivide, sInfo, iPosiz, iAiuto) Then; se i dati non sono stati rilevati,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayMessage (OT_ERROR, hlpNoAutoDati, hlpNoAutoDati_corto)
EndIf; fine controllo aiuto
Return NULLO; in ogni caso, interrompe il flusso restituendo una stringa vuota
EndIf; fine controllo informazioni sul dato
; rileva il segmento relativo al dato richiesto, rendendolo minuscolo e togliendo spazi inutili
Let sDato = StringLower (TagliaSpazi (StringSegment (sTesto, sDivide, iPosiz)))
If !sDato Then; se non  stata rilevata alcuna stringa relativa al tipo di dato,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayMessage (OT_ERROR, hlpInfoErrate, hlpInfoErrate_corto)
EndIf; fine controllo Aiuto
Return NULLO; in ogni caso, interrompe il flusso restituendo una stringa vuota
EndIf; fine controllo rilevamento zona
Let iTotali = StringSegmentCount (sInfo, PIPE); conta il numero delle voci per estrarre il dato
If iTotali < CICLO_VOCI Then; se il numero di analisi  inferiore al minimo,
Let iTotali = CICLO_VOCI; aggiorna il valore
EndIf; fine controllo voci rilevate
Let iFase = SECONDA; predispone la fase di analisi delle voci per partire dalla terza
Let iVoci = PRIMA; e il contatore delle voci per iniziare dalla seconda
While iFase || iVoci < iTotali; continua se una fase  impostata e ci sono voci da elaborare
Let iVoci = iVoci + 1; aggiorna il contatore
Let sVoce = StringSegment (sInfo, PIPE, iVoci); estrae la singola voce
Let iFase = iFase + 1; aggiorna il contatore della fase di estrazione
If iFase == PRIMA Then; se la voce  relativa al separatore,
If sVoce Then; se la stringa non  vuota,
Let sDivide = sVoce; imposta il separatore della zona del dato
Else; altrimenti,
Let sDivide = SPACE; imposta il carattere Spazio
EndIf; fine controllo voce
ElIf iFase == SECONDA Then; se invece si estrae il valore numerico,
Let iPosiz = StringToInt (sVoce); converte e salva la posizione del dato nel segmento estratto
If !iPosiz Then; se nessun valore  stato rilevato,
Let iPosiz = PRIMA; imposta la parte del dato da estrarre
EndIf; fine controllo posizione
; estrae il sottodato, rimuovendo gli spazi in eccesso
Let sDato = TagliaSpazi (StringSegment (sDato, sDivide, iPosiz))
ElIf iFase == TERZA Then; se infine si tratta di una stringa da rimuovere,
If sVoce Then; se tale stringa non  vuota,
; rimuove la parte di dato non necessaria, eliminando anche gli spazi in eccesso
Let sDato = TagliaSpazi (StringReplaceSubstrings (sDato, sVoce, NULLO))
EndIf; fine controllo rimozione stringa
Let iFase = FALSE; e azzera il valore per poter iniziare da capo
EndIf; fine controllo fasi
EndWhile; fine scansione voci
Return sDato; restituisce il testo estratto
EndFunction

String Function NoZero (int iValore)
If iValore Then; se un valore  stato specificato,
Return IntToString (iValore); lo restituisce in forma testuale
Else; altrimenti,
Return NULLO; restituisce una stringa vuota
EndIf; fine controllo valore
EndFunction

Void Function PronunciaDato (string sTitolo, string sDato, int iAiuto)
If sDato Then; se una posizione  stata rilevata,
SayMessage (OT_ERROR, sTitolo, CR); legge il termine solo in caso di messaggi lunghi
SayFormattedMessage (OT_HELP, msg1, NULLO, sDato); legge comunque il dato
ElIf iAiuto Then; se invece non vi  alcun dato, e si  nell'omonima fase,
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, sTitolo); legge un avviso
EndIf; fine controllo dato
EndFunction

Void Function GestisceDato (string sAzione, string sOggetto)
If !SiamoNellaFinestra (EDITING) Then; se non si  nella finestra corretta,
If !(sAzione + sOggetto) Then; se non sono stati specificati dei parametri,
TypeCurrentScriptKey (); ripete i tasti premuti,
EndIf; fine controllo parametri
Return; interrompe il flusso
EndIf; fine controllo finestra
Var
Int iAiuto, ; stato di attivazione della fase Aiuto
Int iNoVoce, ; imposta la disattivazione della fase Aiuto
String sProg, ; eventuale numero progressivo indicato tramite il nome dello script
String sCategoria, ; tipologia dell'azione da compiere
String sDato, ; dato testuale da sottoporre all'azione
String sNomeFile, ; nome completo del documento aperto
String sSuffisso; dato suppletivo da passare come parametro

Let iAiuto = IsSameScript (); rileva l'eventuale doppia pressione dei tasti di attivazione
If !sAzione Then; se l'azione da compiere non  stata specificata come parametro,
Let sProg = SeparaParole (sAzione, sCategoria, sOggetto); estrae i dati dal nome script
Else; altrimenti
Let iNoVoce = SALTA; imposta la successiva disattivazione della fase Aiuto
EndIf; fine controllo parametro
If sAzione == PRONUNCIA Then; se si sono chieste azioni di lettura,
If sCategoria == STATO Then; se si sono richiesti dati dalla Barra di stato,
Let sDato = InfoStato (sOggetto, iAiuto); rileva il dato dalla funzione generica
Else; altrimenti, in tutti gli altri casi,
; Rileva il dato dalla funzione di cui si compone il nome
Let sDato = NoZero (CallFunctionByName (sCategoria + sOggetto))
EndIf; fine controllo categoria
CallFunctionByName (sAzione + DATO, sOggetto, sDato, iAiuto); esegue l'azione
ElIf sAzione == CERCA Then; se invece si sono chieste delle ricerche,
CercaDato (sCategoria, sOggetto, iAiuto); esegue l'azione
Else; se invece servono operazioni su documenti,
If !DocumentoCorrente (sNomeFile, sSuffisso) Then; se non vi sono dati sul file aperto,
If iAiuto Then; se  attiva la fase Aiuto,
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, msgTitolo); legge l'avviso
EndIf; fine controllo aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo documento
If sAzione == SALVA; se si vuole il salvataggio di un contrassegno,
|| sAzione == TORNA Then; o si vuole ritornarvi,
If !iNoVoce Then; se l'impostazione non  disattivata,
Let iAiuto = TRUE; imposta la fase
EndIf; fine controllo disattivazione
CallFunctionByName (sAzione + DATO, sNomeFile, sOggetto, sProg, iAiuto); esegue l'azione
Else; se invece l'azione non  stata riconosciuta,
If iAiuto Then; se la fase  attiva,
SayFormattedMessage (OT_ERROR, hlpNoAzione, hlpNoAzione_corto, sAzione); legge l'avviso
EndIf; fine controllo Aiuto
EndIf; fine secondo controllo azioni
EndIf; fine primo controllo azioni
EndFunction

Int Function ValoreRiga ()
Return GetCursorRow (); restituisce il dato della funzione nativa
EndFunction

Int Function ValoreColonna ()
Return GetCursorCol (); restituisce il valore della funzione nativa
EndFunction

Int Function ValoreLunghezza ()
If SiamoNellaFinestra (MANAGER) Then; se ci si trova nella finestra dell'Editor di Script,
; restituisce il valore numerico, convertito dal risultato dell'apposita funzione
Return StringToInt (InfoStato (LUNGHEZZA, IsSameScript ()))
ElIf SiamoNellaFinestra (RIGHE) Then; se invece si  in un applicativo gestito a righe,
Return GetLineCount (); restituisce il valore rilevato dalla funzione nativa per le righe
ElIf SiamoNellaFinestra (POSIZIONE) Then; se infine si basa sulla posizione assoluta,
Return GetCurrentDocumentLength (); restituisce la posizione tramite la funzione nativa
Else; altrimenti, nelle altre finestre,
If IsSameScript () Then; se  stata attivata la fase Aiuto,
SayMessage (OT_ERROR, hlpNoFinestra, hlpNoFinestra_corto); legge l'avviso
EndIf; fine controllo Aiuto
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo finestre
EndFunction

Script PronunciaValoreRiga ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script PronunciaValoreColonna ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script PronunciaValoreLunghezza ()
GestisceDato (); chiama l'apposita funzione
EndScript

Int Function NumeroVersione ()
; restituisce il valore corrispondente alle prime due cifre della versione di Jaws
Return StringToInt (StringLeft (IntToString (GetJFWVersion ()), 2))
EndFunction

Int Function PosizioneCursore ()
Return GetCursorRow (); restituisce il valore dalla funzione nativa
EndFunction

Int Function ScrivePuntatore (string sNomeFile, string sProg, int iValore)
Return ScriveDato (; restituisce l'esito della scrittura di puntatore o contrassegni numerati
SEGNI, ; valore che identifica l'archivio in cui scrivere
CTS + sNomeFile, ; sezione dell'archivio
CHIAVE_SEGNI + sProg, ; chiave del dato
IntToString (iValore)); dato da scrivere, convertito in forma testuale
EndFunction

Int Function LeggeSegni (string sNomeFile, string sProg, string sOggetto)
Var String sPrefisso; termine da premettere nella sezione
If sProg ; se  stato specificato un numero progressivo,
&& sOggetto == CONTRASSEGNO Then; e se si vuole un contrassegno numerato o l'ultimo,
If sProg == ZERO Then; se  stata indicata la cifra del valore 0,
Let sProg = NULLO; cancella il dato
EndIf; fine controllo cifra progressiva
Let sPrefisso = CTS; inserisce comunque un prefisso per il nome della sezione in cui scrivere
EndIf; fine controllo preliminare
Return LeggeValore (SEGNI, sPrefisso + sNomeFile, CHIAVE_SEGNI + sProg); legge il dato
EndFunction

Int Function PuntatoreSegni (string sNomeFile, int iValore)
If iValore >= FALSE Then; se un valore non  negativo,
; reimposta il puntatore dei contrassegni e ne restituisce l'esito
Return ScrivePuntatore (sNomeFile, NULLO, iValore)
Else; altrimenti,
Return LeggeSegni (sNomeFile, ZERO, CONTRASSEGNO); ritorna il valore del puntatore
EndIf; fine controllo valore
EndFunction

Int Function AggiornaSegni (string sNomeFile, int iValore, string sProg)
Var
int i, ; il contatore del ciclo
String sChiavi, ; l'elenco delle chiavi dei contrassegni registrati
Int iContrassegni, ; il numero dei contrassegni
Int iPrima; il valore del contrassegno precedente

If sProg Then; se un numero progressivo  stato specificato,
; restituisce l'esito della scrittura nell'apposita sezione, interrompendo il flusso
Return ScrivePuntatore (sNomeFile, sProg, iValore)
EndIf; fine controllo numero progressivo
Let sChiavi = LeggeChiavi (SEGNI, sNomeFile); rileva le chiavi dei contrassegni registrati
Let iContrassegni = StringSegmentCount (sChiavi, PIPE); conta i contrassegni rilevati
If iContrassegni Then; se vi  almeno un dato registrato,
For i = iContrassegni To 1 Descending; fa scalare le precedenti registrazioni
If i <= MAX_SEGNI Then; se il contatore  inferiore o uguale al loro numero massimo,
; rileva il dato del contrassegno precedente,
Let iPrima = LeggeValore (SEGNI, sNomeFile, CHIAVE_SEGNI + NoZero (i - 1))
; e sovrascrive, o crea, un contrassegno con il valore appena rilevato
ScriveValore (SEGNI, sNomeFile, CHIAVE_SEGNI + NoZero (i), iPrima)
EndIf; fine controllo numero massimo
EndFor; fine ciclo di sovrascrittura
EndIf; fine controllo numero contrassegni
If ScriveValore (SEGNI, sNomeFile, CHIAVE_SEGNI, iValore) Then; se la scrittura riesce,
Return PuntatoreSegni (sNomeFile, FALSE); inizializza il puntatore dei contrassegni
Else; altrimenti,
Return FALSE; restituisce un valore nullo
EndIf; fine controllo scrittura
EndFunction

Int Function SalvaDato (string sNomeFile, string sOggetto, String sProg, int iAiuto)
Var
Int iValore; posizione da registrare

If NumeroVersione () >= NUOVE Then; se quella in uso  una versione di Jaws dalla 2018,
SpeechOff (); spegne la sintesi
PerformScript DefineATempPlaceMarker(); esegue lo script nativo
SpeechOn (); riattiva la sintesi
Else; Altrimenti, per le versioni precedenti,
SaveCurrentLocation (); registra la posizione per i puntatori interni di Jaws
EndIf; fine controllo versione
If sOggetto == ESCE Then; se si  usciti dall'applicazione,
DeleteFile (NomeArchivio (TEMPORANEO)); si cancella l'intero file con le aperture
ElIf sOggetto == CHIUDE Then; se invece si  chiuso solo il documento corrente,
CancellaChiave (TEMPORANEO, APERTURA, sNomeFile); rimuove solo la nota sul file
EndIf; fine controllo tipo di azione
Let iValore = PosizioneCursore (); rileva il dato da registrare
If !iValore Then; se il valore  nullo,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo valore
; se il nuovo contrassegno  uguale all'ultimo registrato,
If iValore == LeggeSegni (sNomeFile, sProg, sOggetto) Then
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpGiaSegno, hlpGiaSegno_corto); legge l'avviso
EndIf; fine controllo aiuto
Return FALSE; interrompe il flusso, restituendo un risultato nullo
ElIf AggiornaSegni (sNomeFile, iValore, sProg) Then; se invece la registrazione riesce,
If iAiuto Then; se  attiva la fase, avvisa dell'esito
SayFormattedMessage (OT_ERROR, hlpOkSegno, hlpOkSegno_corto, sProg)
EndIf; fine controllo Aiuto
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; Altrimenti, se la scrittura fallisce,
If iAiuto Then; se  attiva la fase, segnala l'errore
SayFormattedMessage (OT_ERROR, hlpNoCts, hlpNoCts_corto, sProg)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo scrittura
EndFunction

Int Function ScorreSegni (string sNomeFile, string sOggetto, ; prima riga d'intestazione,
string sChiavi, int iConta, string ByRef sProg); seconda riga, con gli altri tre parametri
Var
Int iAttuale, ; valore del puntatore dei contrassegni
Int iPosiz; posizione del contrassegno nell'archivio

Let iAttuale = PuntatoreSegni (sNomeFile, -1); rileva l'attuale puntatore dei contrassegni
If sOggetto == PRIMO Then; se si  chiesto il contrassegno pi vecchio,
Let iPosiz = iConta; imposta il valore relativo
ElIf sOggetto == ULTIMO Then; se invece si  richiesto l'ultimo registrato,
Let iPosiz = FALSE; azzera il valore
ElIf sOggetto == PRECEDENTE Then; se si  chiesto il contrassegno prima,
Let iPosiz = iAttuale + 1; aumenta il valore
ElIf sOggetto == SUCCESSIVO Then; se infine si  chiesto il contrassegno dopo,
Let iPosiz = iAttuale - 1; diminuisce il valore
EndIf; fine controllo tipo azione
If iPosiz == iAttuale ; se il contrassegno chiesto  quello gi sul puntatore,
|| iPosiz > iConta ; o se quello chiesto  oltre il primo registrato,
|| iPosiz < FALSE Then; oppure se il valore  inferiore a zero,
Suona (ERRORE1); emette un suono di avviso,
Return FALSE; e restituisce un risultato nullo
Else; se invece la posizione  valida,
Let sProg = NoZero (iPosiz); aggiorna il valore da trasmettere
PuntatoreSegni (sNomeFile, iPosiz); aggiorna anche il contatore
If iPosiz == FALSE Then; se si  sul contrassegno pi recente,
Suona (ULTIMO_SEGNO); emette il suono relativo
ElIf iPosiz == iConta Then; se invece si  sul contrassegno meno recente,
Suona (PRIMO_SEGNO); emette il suono relativo
Else; altrimenti
Suona (Nota (iPosiz)); emette la nota corrispondente
EndIf; fine controllo suoni
Return TRUE; consente di proseguire il flusso nella funzione chiamante
EndIf; fine controllo valore
EndFunction

Int Function MuoveAllaRiga (int iValore)
Var Int iStato; indica lo stato di attivazione della sintesi
Let iStato = ControllaSintesi (FALSE); verifica se la sintesi  spenta, salvandone l'esito
TypeKey (CONTROL_G); richiama il comando di spostamento alla riga
Pause ()
TypeString (IntToString (iValore)); immette la riga a cui portarsi
EnterKey ()
Pause ()
ControllaSintesi (iStato); verifica se riattivare la sintesi
EndFunction

Void Function SpostaCursore (int iPosiz, string sProg, int iAiuto)
If SiamoNellaFinestra (RIGHE) Then; se l'applicativo corrente funziona a righe,
MuoveAllaRiga (iPosiz); effettua lo spostamento con il comando dell'applicativo
If iAiuto Then; se  attiva la fase,
SayFormattedMessage (OT_ERROR, msgTornaA, msgSecondo, RIGA, iPosiz)
EndIf; fine controllo Aiuto
ElIf SiamoNellaFinestra (POSIZIONE) Then; se invece conta la posizione assoluta,
MoveToDocumentOffset (iPosiz ); si sposta alla posizione memorizzata
If iAiuto Then; se  attiva la fase,
If !sProg Then; se non  indicato alcun numero, avvisa di portarsi all'ultimo contrassegno
SayFormattedMessage (OT_ERROR, msg2, msg1, ULTIMO, CONTRASSEGNO)
Else; altrimenti, se un valore  stato rilevato, avvisa di portarsi al contrassegno numerato
SayFormattedMessage (OT_ERROR, msg2, msgSecondo, CONTRASSEGNO, sProg)
EndIf; fine controllo tipo contrassegno
EndIf; fine controllo messaggi
Else; se la finestra non  stata riconosciuta,
SayMessage (OT_ERROR, hlpNoRegistra, hlpNoRegistra_corto); legge l'avviso
EndIf; fine controllo finestre
EndFunction

Int Function TornaDato (string sNomeFile, string sOggetto, String sProg, int iAiuto)
Var
Int iPosiz, ; posizione del cursore
Int iTotale, ; lunghezza del file aperto
Int iAperto, ; indicatore di una nuova apertura
String sChiavi, ; elenco dei contrassegni registrati
Int iConta; numero dei contrassegni rilevati

If sOggetto == APERTURA Then; se si deve verificare l'apertura del documento,
If LeggeDato(TEMPORANEO, APERTURA, sNomeFile) Then; se il file  gi aperto,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
Else; altrimenti, se si  al primo ingresso nel documento, ne annota l'apertura
Let iAperto = ScriveDato (TEMPORANEO, APERTURA, sNomeFile, ZERO)
EndIf; fine controllo apertura
ElIf sOggetto != CONTRASSEGNO Then; se invece non si  chiesto l'ultimo contrassegno,
Let sChiavi = LeggeChiavi (SEGNI, sNomeFile); rileva i contrassegni
Let iConta = StringSegmentCount (sChiavi, PIPE) - 1; conta i contrassegni, meno un'unit
If iConta Then; se vi sono almeno due contrassegni registrati, lo 0 e l'1,
If !ScorreSegni (sNomeFile, sOggetto, sChiavi, iConta, sProg) Then; se non  valido,
Return; interrompe il flusso
Else; altrimenti, se il flusso pu proseguire,
Let iAiuto = FALSE; disattiva l'omonima fase
EndIf; fine controllo scorrimento
EndIf; fine controllo numero contrassegni
EndIf; fine controllo oggetto
Let iPosiz = LeggeSegni (sNomeFile, sProg, sOggetto); rileva il valore del contrassegno
If !iPosiz Then; se nessun valore  stato rilevato,
If iAiuto Then; se  attiva la fase, segnala l'errore
SayFormattedMessage (OT_ERROR, hlpNoSegno, hlpNoSegno_corto, sProg)
EndIf; fine controllo Aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo valore
If sOggetto == CONTRASSEGNO Then; se si  chiesto l'ultimo contrassegno registrato,
PuntatoreSegni (sNomeFile, FALSE); resetta il puntatore dei contrassegni
EndIf; fine controllo tipo ritorno
If !iAperto ; se non si  appena rientrati nel file,
&& iPosiz == PosizioneCursore () Then; e se il cursore  gi sul contrassegno,
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpSulPosto, hlpSulPosto_corto); legge l'avviso
EndIf; fine controllo aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo contrassegno
Let iTotale = ValoreLunghezza (); tenta di rilevare la lunghezza del documento aperto
If !iTotale ; se la lunghezza totale non  stata rilevata,
|| (iTotale && iPosiz <= iTotale) Then; oppure se il valore c', ma non inferiore all'esistente,
SpostaCursore (iPosiz, sProg, iAiuto); esegue lo spostamento del cursore nel documento
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
Else; se invece il numero memorizzato  superiore alla lunghezza complessiva,
If iTotale > 1 Then; se vi sono pi di una riga nel file,
JAWSBottomOfFile (); si porta alla fine del documento
EndIf; fine controllo lunghezza
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpFineFile, hlpFineFile_corto); legge l'avviso
EndIf; fine controllo Aiuto
EndIf; fine controllo lunghezza documento
EndFunction

Script TornaContrassegno ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaPrimo ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaUltimo ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaPrecedente ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaSuccessivo ()
GestisceDato (); chiama l'apposita funzione
EndScript

Void Function ComandoTrova ()
TypeKey (CONTROL_F); apre la finestra di dialogo per la ricerca
EndFunction

Script MetteMacroTesto3 ()
MetteTesto (MARK_PLACE, TRUE); inserisce la riga di codice, andando poi a capo
EndScript

Script MetteMacroTesto4 ()
MetteTesto (FOCUS_CHANGED, TRUE); inserisce la riga di codice, andando poi a capo
EndScript

Script EsceProgramma ()
GestisceDato (SALVA, ESCE) ; esegue il salvataggio, annotando l'uscita dal documento
PronunciaEsegue (ALT_F4, TRUE); forza l'invio dei tasti specificati, leggendo lo script attivo
EndScript

Script ChiudeFinestra ()
GestisceDato (SALVA, CHIUDE) ; salva la posizione simulando la chiusura del documento
PronunciaEsegue (); ripete i tasti premuti, leggendo il nome dello script
EndScript

Void Function VaiEstremi (string sOggetto)
If sOggetto == PRIMO Then; se si  chiesta la prima occorrenza,
JAWSTopOfFile (); si porta all'inizio del documento
ElIf sOggetto == ULTIMO Then; se invece si  chiesta l'ultima occorrenza,
JAWSBottomOfFile (); si porta alla fine del documento
EndIf; fine controllo spostamento
Pause ()
EndFunction

Int Function EsegueRicerca (string ByRef sTesto, string sOggetto)
Var
Int iStato, ; indica lo stato di attivazione della sintesi
Int iErrore; esito della ricerca

Let iStato = ControllaSintesi (); verifica se spegnere la sintesi vocale, salvandone l'esito
ComandoTrova (); attiva la finestra di ricerca testo
Pause ()
If sTesto Then; se un qualche testo  stato specificato,
TypeString (sTesto); lo immette nel campo di ricerca
Pause ();
Else; altrimenti,
Let sTesto = GetObjectValue (); trasmette per riferimento la stringa da cercare
EndIf; fine controllo testo
; se si  richiesta la ricerca dall'inizio oppure in avanti,
If sOggetto == PRIMO || sOggetto == SUCCESSIVO Then
TypeKey (ALT_G); attiva la ricerca all'ingi
Else; altrimenti,
TypeKey (ALT_S); attiva la ricerca all'ins
EndIf; fine controllo direzione indietro
EnterKey ();
EscapeKey ()
Delay (ATTESA); ritarda il flusso per i decimi di secondo impostati
If GetObjectSubTypeCode () == PULSANTE_RADIO Then; se si resta nella finestra,
EscapeKey (); ne esce,
Let iErrore = TRUE; e imposta la conclusione anomala
EndIf; fine controllo esito
ControllaSintesi (iStato); verifica se riattivare la sintesi
If !iErrore Then; se non si sono verificate anomalie,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Int Function EstremiDocumento (string sTesto, string ByRef sOggetto)
Var
String sTitolo, ; intestazione della finestra di dialogo
String sMessaggio; testo per la finestra di dialogo

SpeechOn (TRUE); riattiva la sintesi, con lo svuotamento del buffer
If sOggetto == SUCCESSIVO Then; se si era chiesta l'occorrenza seguente,
Let sTitolo = FormatString (ttlContinuaCerca, _A, msgFine); formatta il titolo
Let sMessaggio = FormatString (msgContinuaCerca, msgInizio); formatta anche la conferma
Let gsPartenza = PRIMO; si assegna al tipo di azione la ricerca dall'inizio
Else; se invece si era chiesta l'occorrenza precedente,
Let sTitolo = FormatString (ttlContinuaCerca, _O, msgInizio); formatta il titolo
Let sMessaggio = FormatString (msgContinuaCerca, msgFine); formatta anche la conferma
Let gsPartenza = ULTIMO; imposta il tipo di azione per la ricerca dalla fine
EndIf; fine controllo tipo richiesta
; propone se continuare o meno la ricerca dalla parte opposta
If ChiedeConferma (sTitolo, sMessaggio, FALSE, FALSE, TRUE) Then; se si conferma di proseguire,
VaiEstremi (gsPartenza); esegue lo spostamento per continuare la ricerca,
Return EsegueRicerca (sTesto, sOggetto);poi riprende la ricerca e ne restituisce l'esito
Else; se invece la ricerca  stata interrotta,
Return TRUE; restituisce comunque la prosecuzione del flusso
EndIf; fine controllo scelta
EndFunction

Int Function InizioDocumento ()
If SiamoNellaFinestra (RIGHE) Then; se l'applicativo corrente funziona a righe,
Return TRUE; restituisce un'unit come prima posizione del file
Else; se invece l'applicativo funziona con la posizione assoluta,
Return FALSE; restituisce uno zero come prima posizione
EndIf; fine controllo finestra
EndFunction

Int Function MossoDaPrima (string sOggetto)
Var Int iAttuale; posizione del cursore
Pause ()
Let iAttuale = PosizioneCursore (); memorizza la posizione corrente del cursore
If iAttuale == gnUltima ;se questa  uguale a quella memorizzata nell'ultimo contrassegno,
|| (sOggetto == PRIMO && iAttuale == InizioDocumento (); o, se si  partiti e rimasti all'inizio,
|| (sOggetto == ULTIMO && iAttuale == ValoreLunghezza ())) Then; o, partiti e rimasti alla fine,
Return FALSE; restituisce un risultato nullo
Else; altrimenti, in tutti gli altri casi,
Return TRUE; restituisce la conferma dello spostamento
EndIf; fine controllo cursore
EndFunction

Void Function CercaDato (string sCategoria, string sOggetto, int iAiuto)
Var
Int iStato, ; stato di attivazione della sintesi
String sTesto; stringa da cercare

; verifica lo spegnimento della sintesi, azzerando il buffer
Let iStato = ControllaSintesi (FALSE, TRUE)
Let gnUltima = PosizioneCursore (); registra la posizione di partenza
VaiEstremi (sOggetto); effettua l'eventuale spostamento agli estremi del documento
If sCategoria == CODICE Then; se si  chiesto di cercare l'etichetta di inizio codice,
Let sTesto = INIZIO_PERSONALE; imposta la stringa relativa
EndIf; fine controllo categoria
If !EsegueRicerca (sTesto, sOggetto) Then; se la ricerca ha avuto un esito anomalo,
If !EstremiDocumento (sTesto, sOggetto) Then; se poi si  verificato un nuovo errore,
; si propone una finestra con un avviso da poter solo confermare, senza icone e suoni
ChiedeConferma (FormatString (msgNoTesto, sTesto), NULLO, OK, FALSE, TRUE)
Let sOggetto = gsPartenza; imposta l'ultima partenza come oggetto dello spostamento
EndIf; fine controllo estremi
EndIf; fine controllo ricerca
ControllaSintesi (iStato, TRUE); verifica l'eventuale riattivazione della sintesi
If !MossoDaPrima (sOggetto) ; se il cursore non si  spostato,
&& (sOggetto == PRIMO || sOggetto == ULTIMO) Then; e si  cercato dalle estremit del file,
SpostaCursore (gnUltima); ritorna al punto di partenza
EndIf; fine controlli esito ricerca
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndFunction

Script CercaCodicePrimo ()
GestisceDato (); chiama la funzione generica
EndScript

Script CercaCodiceUltimo ()
GestisceDato (); chiama la funzione generica
EndScript

Script CercaCodicePrecedente ()
GestisceDato (); chiama la funzione generica
EndScript

Script CercaCodiceSuccessivo ()
GestisceDato (); chiama la funzione generica
EndScript

